// PINPadDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SignPay_OPOSDemo.h"
#include "PINPadDlg.h"
#include "Opos.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPINPadDlg property page

IMPLEMENT_DYNCREATE(CPINPadDlg, CPropertyPage)

CPINPadDlg::CPINPadDlg() : CPropertyPage(CPINPadDlg::IDD)
{
	//{{AFX_DATA_INIT(CPINPadDlg)
	m_OpenEdit = _T("");
	m_CoDEdit = _T("");
	m_SoDEdit = _T("");
	m_DeviceName = _T("");
	m_ClaimEdit = _T("");
	m_BeginEdit = _T("");
	m_ANumber = _T("");
	m_bEnableDevice = FALSE;
	m_bDataEvent = FALSE;
	m_bFreeze = FALSE;
	m_PinEntryEdit = _T("");
	m_PinEdit = _T("");
	m_CoVEdit = 0;
	m_SoVEdit = 0;
	//}}AFX_DATA_INIT
}

CPINPadDlg::~CPINPadDlg()
{
}

void CPINPadDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPINPadDlg)
	DDX_Control(pDX, IDC_COMBO_PINPAD, m_ComPIN);
	DDX_Control(pDX, IDC_PINPAD1, m_cPINPad);
	DDX_Text(pDX, IDC_EDIT_OPENRESULT, m_OpenEdit);
	DDX_Text(pDX, IDC_EDIT_CODES, m_CoDEdit);
	DDX_Text(pDX, IDC_EDIT_SODES, m_SoDEdit);
	DDX_Text(pDX, IDC_EDIT_DEVICENAME, m_DeviceName);
	DDX_Text(pDX, IDC_EDIT_CLAIMRESULT, m_ClaimEdit);
	DDX_Text(pDX, IDC_EDIT_BEGINRESULT, m_BeginEdit);
	DDX_Text(pDX, IDC_EDIT_ACCOUNT, m_ANumber);
	DDX_Check(pDX, IDC_CHECKENABLEDEVICE, m_bEnableDevice);
	DDX_Check(pDX, IDC_CHECKEDATAEVENT, m_bDataEvent);
	DDX_Check(pDX, IDC_CHECKEFREZZE, m_bFreeze);
	DDX_Text(pDX, IDC_EDIT_PINENTRY, m_PinEntryEdit);
	DDX_Text(pDX, IDC_EDIT_ENABLEPINRESULT, m_PinEdit);
	DDX_Text(pDX, IDC_EDIT_COVER, m_CoVEdit);
	DDX_Text(pDX, IDC_EDIT_SOVER, m_SoVEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPINPadDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CPINPadDlg)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_CLAIM, OnButtonClaim)
	ON_BN_CLICKED(IDC_BUTTON_BEGIN, OnButtonBegin)
	ON_BN_CLICKED(IDC_CHECKENABLEDEVICE, OnCheckenabledevice)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_END, OnButtonEnd)
	ON_BN_CLICKED(IDC_BUTTON_RELEASE, OnButtonRelease)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_BN_CLICKED(IDC_CHECKEDATAEVENT, OnCheckedataevent)
	ON_BN_CLICKED(IDC_CHECKEFREZZE, OnCheckefrezze)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPINPadDlg message handlers

void CPINPadDlg::OnButtonOpen() 
{

	// TODO: Add your control notification handler code here
	UpdateData(true);
	int res = 0;
	int index = m_ComPIN.GetCurSel();
	if(index == 0)
		res = m_cPINPad.Open(_T("SecurePIN_Sign&Pay-HID"));
	else
		res = m_cPINPad.Open(_T("SecurePIN_Sign&Pay-RS232"));
	if(res == OPOS_SUCCESS)
		m_OpenEdit = "OPEN_SUCCESS";
	else if(res == OPOS_E_NOSERVICE)
			m_OpenEdit = "OPOS_E_NOSERVICE";
	else
	{
		int nres = m_cPINPad.GetOpenResult();
		switch(nres)
		{	
		case OPOS_OR_REGBADNAME:
			m_OpenEdit = "Device name is not exist";
			break;
		case OPOS_OR_FAILEDOPEN:
			m_OpenEdit = "OPOS_OR_FAILEDOPEN";
			break;
		case OPOS_ORS_NOPORT:
			m_OpenEdit = "OPOS_ORS_NOPORT";
			break;
		case OPOS_ORS_CONFIG:
			m_OpenEdit = "OPOS_ORS_CONFIG";
			break;
		default:
			m_OpenEdit = "OPEN_ERROR";
			break;
		}
	}
	m_CoDEdit = m_cPINPad.GetControlObjectDescription();
	m_CoVEdit = m_cPINPad.GetControlObjectVersion();
	m_SoDEdit = m_cPINPad.GetServiceObjectDescription();
	m_SoVEdit = m_cPINPad.GetServiceObjectVersion();
	m_DeviceName = m_cPINPad.GetDeviceName();

	UpdateData(FALSE);
}

void CPINPadDlg::OnButtonClaim() 
{
	// TODO: Add your control notification handler code here
	int res = m_cPINPad.ClaimDevice(100);
	switch(res)	
	{
		case OPOS_SUCCESS:
			m_ClaimEdit = "ClaimDevice_SUCCESS";
			break;
		case OPOS_E_TIMEOUT:
			m_ClaimEdit = "OPOS_E_TIMEOUT";
			break;
		case OPOS_E_CLOSED:
			m_ClaimEdit = "The Device not Opened";
			break;
		default:
			m_ClaimEdit = "Claim ERROR";
			break;
	}	
	UpdateData(FALSE);
}

void CPINPadDlg::OnButtonBegin() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	m_cPINPad.SetAccountNumber(m_ANumber);
	int res = m_cPINPad.BeginEFTTransaction("DUKPT",123);			
	if(res == OPOS_SUCCESS)
		m_BeginEdit = "BeginEFT_SUCCESS";
	else
	{
		int nres = m_cPINPad.GetOpenResult();
		switch(nres)
		{	
		case OPOS_E_CLOSED:
			m_BeginEdit = "OPOS_E_CLOSED";
			break;
		case OPOS_E_ILLEGAL:
			m_BeginEdit = "OPOS_E_ILLEGAL";
			break;		
		default:
			m_BeginEdit = "BeginEFT_ERROR";
			break;
		}
	}
	UpdateData(FALSE);

}

BOOL CPINPadDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_ANumber = "1234567890123456";
	m_ComPIN.SetCurSel(0);
	UpdateData(false);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPINPadDlg::OnCheckenabledevice() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	if(m_bEnableDevice)
	{		
		m_cPINPad.SetDeviceEnabled(TRUE);
		
	}
	else
		m_cPINPad.SetDeviceEnabled(FALSE);

}

BEGIN_EVENTSINK_MAP(CPINPadDlg, CPropertyPage)
    //{{AFX_EVENTSINK_MAP(CPINPadDlg)
	ON_EVENT(CPINPadDlg, IDC_PINPAD1, 1 /* DataEvent */, OnDataEventPinpad1, VTS_I4)
	ON_EVENT(CPINPadDlg, IDC_PINPAD1, 3 /* ErrorEvent */, OnErrorEventPinpad1, VTS_I4 VTS_I4 VTS_I4 VTS_PI4)
	ON_EVENT(CPINPadDlg, IDC_PINPAD1, 2 /* DirectIOEvent */, OnDirectIOEventPinpad1, VTS_I4 VTS_PI4 VTS_PBSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CPINPadDlg::OnDataEventPinpad1(long Status) 
{
	// TODO: Add your control notification handler code here
	
	CString str;
	if(Status == 2)//Cancel
	{
		str = "PIN Cancel";
	}
	else	
		str = m_cPINPad.GetEncryptedPIN();
	m_PinEntryEdit = str;
	m_bDataEvent = m_cPINPad.GetDataEventEnabled();	
	UpdateData(false);
}

void CPINPadDlg::OnButtonEnable() 
{
	// TODO: Add your control notification handler code here
	m_PinEntryEdit = " ";	
	int res = m_cPINPad.EnablePINEntry();

	
	if(res == OPOS_SUCCESS)
		m_PinEdit = "EnablePINEntry_SUCCESS";
	else
	{
		int nres = m_cPINPad.GetOpenResult();
		switch(nres)
		{		
		case OPOS_E_ILLEGAL:
			m_PinEdit = "OPOS_E_ILLEGAL";
			break;		
		default:
			m_PinEdit = "PINENTRY_ERROR";
			break;
		}
	}
	UpdateData(FALSE);
}

void CPINPadDlg::OnButtonEnd() 
{
	// TODO: Add your control notification handler code here
	m_cPINPad.EndEFTTransaction(123);
//	m_bEnableDevice = false;	
	UpdateData(false);
}

void CPINPadDlg::OnButtonRelease() 
{
	// TODO: Add your control notification handler code here

	m_cPINPad.ReleaseDevice();
	m_bEnableDevice = false;
	m_bDataEvent = false;
	m_bFreeze = false;
	UpdateData(false);
}

void CPINPadDlg::OnButtonClose() 
{
	// TODO: Add your control notification handler code here
	m_bEnableDevice = false;
	m_bDataEvent = false;
	m_bFreeze = false;
	m_PinEntryEdit = "";
	m_PinEdit = "";
	m_BeginEdit = "";
	m_OpenEdit = "";
	m_ClaimEdit = "";
	m_CoDEdit = "";	
	m_SoDEdit = "";
	m_CoVEdit = 0;	
	m_SoVEdit = 0;
	m_DeviceName = "";	

	int res = m_cPINPad.Close();
	UpdateData(false);
}

void CPINPadDlg::OnCheckedataevent() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	m_cPINPad.SetDataEventEnabled(m_bDataEvent);
	
}

void CPINPadDlg::OnCheckefrezze() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	m_cPINPad.SetFreezeEvents(m_bFreeze);
}

void CPINPadDlg::OnErrorEventPinpad1(long ResultCode, long ResultCodeExtended, long ErrorLocus, long FAR* pErrorResponse) 
{
	// TODO: Add your control notification handler code here
	
	m_PinEntryEdit = "PIN Error";
	m_bDataEvent = m_cPINPad.GetDataEventEnabled();	
	UpdateData(false);
}



void CPINPadDlg::OnDirectIOEventPinpad1(long EventNumber, long FAR* pData, BSTR FAR* pString) 
{
	// TODO: Add your control notification handler code here
	m_PinEntryEdit = CString(* pString);
	UpdateData(false);
}
